package me.km;

import net.minecraft.block.Block;
import net.minecraft.block.state.IBlockState;
import net.minecraft.client.renderer.block.model.ModelBakery;
import net.minecraft.client.renderer.block.model.ModelResourceLocation;
import net.minecraft.client.renderer.block.statemap.StateMapperBase;
import net.minecraft.client.renderer.entity.Render;
import net.minecraft.entity.Entity;
import net.minecraft.item.Item;
import net.minecraftforge.client.model.ModelLoader;
import net.minecraftforge.fluids.IFluidBlock;
import net.minecraftforge.fml.client.registry.RenderingRegistry;

public class ClientProxy extends CommonProxy 
{
    @Override
    public void registerItemRenderer(Item item, int meta, String id) 
    {
        ModelLoader.setCustomModelResourceLocation(item, meta, new ModelResourceLocation(KajetansMod.MODID + ":" + id, null));
    }
    
    @Override
    public void registerFluidModel(IFluidBlock fluidBlock) 
    {
        final Item item = Item.getItemFromBlock((Block) fluidBlock);
        assert item != null;
        ModelBakery.registerItemVariants(item);
        ModelResourceLocation modelResourceLocation = new ModelResourceLocation(KajetansMod.MODID + ":fluids", fluidBlock.getFluid().getName());
        ModelLoader.setCustomMeshDefinition(item, MeshDefinitionFix.create(stack -> modelResourceLocation));
        ModelLoader.setCustomStateMapper((Block) fluidBlock, new StateMapperBase() 
        {
            @Override
            protected ModelResourceLocation getModelResourceLocation(IBlockState state) 
            {
                return modelResourceLocation;
            }
        });
    }
    
    @Override
    public void registerEntityRenderer(Class<? extends Entity> c, Render<? extends Entity> r)
    {
        RenderingRegistry.registerEntityRenderingHandler(c, r);
    }
}
