package me.km;

import me.km.api.Module;
import me.km.api.SimpleConfig;
import me.km.blocks.ModBlocks;
import me.km.chatmanager.ChatManager;
import me.km.databank.DataBank;
import me.km.entities.ModEntities;
import me.km.fluids.ModFluids;
import me.km.items.ModItems;
import me.km.playerbank.PlayerBank;
import me.km.playerbank.PlayerManager;
import me.km.scheduler.SnuviScheduler;
import me.km.scoreboard.ScoreboardAPI;
import net.minecraft.server.MinecraftServer;
import net.minecraft.util.text.TextFormatting;
import net.minecraftforge.fml.common.FMLCommonHandler;
import net.minecraftforge.fml.common.Mod;
import net.minecraftforge.fml.common.SidedProxy;
import net.minecraftforge.fml.common.event.FMLInitializationEvent;
import net.minecraftforge.fml.common.event.FMLPostInitializationEvent;
import net.minecraftforge.fml.common.event.FMLPreInitializationEvent;
import net.minecraftforge.fml.common.event.FMLServerStartingEvent;
import net.minecraftforge.fml.common.event.FMLServerStoppingEvent;

@Mod(modid = KajetansMod.MODID, version = KajetansMod.VERSION, name = KajetansMod.NAME)
public class KajetansMod
{    
    public static SimpleConfig conf;
    
    public static DataBank databank;
    public static SnuviScheduler scheduler;
    public static PlayerManager playerbank;
    public static Module generalCommands;
    public static ChatManager chatManager;
    //public static Module afkManager;
    //public static Module plots;
    //public static Module blocks;
    //public static Module datatools;
    //public static WorldData worldManager;
    //public static Module environment;
    //public static QuestAPI quest;
    //public static JobAPI jobs;
    //public static EffectUtils effects;
    //public static SkillManager skills;
    //public static Module scrolls;
    //public static Customs customs;
    //public static PiercingAPI piercing;
    public static ScoreboardAPI scoreboard;
    
    @SidedProxy(serverSide = "me.km.CommonProxy", clientSide = "me.km.ClientProxy")
    public static CommonProxy proxy;

    public static final String MODID = "km";
    public static final String NAME = "Kajetans Mod";
    public static final String VERSION = "0.0.1";

    @Mod.Instance(MODID)
    public static KajetansMod instance;
    
    public static MinecraftServer server;

    @Mod.EventHandler
    public void preInit(FMLPreInitializationEvent event) 
    {
        System.out.println(NAME + " is loading!");
        ModFluids.init();
        ModItems.init();
        ModBlocks.init();
    }
    
    @Mod.EventHandler
    public void serverStarting(FMLServerStartingEvent e) 
    {
        server = FMLCommonHandler.instance().getMinecraftServerInstance();
        
        // Konfiguration und Error-Dummy
        Module error = new Module("ERROR", "ERROR", TextFormatting.RED);
        conf = new SimpleConfig(error, "config", true);
        
        // Datenbankverbindung
        databank = new DataBank("DataBank", "DataBank", TextFormatting.RED);
        if(!databank.openDataBankConnection(conf.getString("user", "root"), conf.getString("password", "")))
        {
            return;
        }
        
        // Scheduler
        scheduler = new SnuviScheduler("Scheduler", "Scheduler", TextFormatting.GREEN);
        scheduler.registerEvents("me.km.scheduler");
                
        // Spielerdatenbank
        playerbank = new PlayerManager("PlayerBank", "PlayerBank", TextFormatting.RED);
        playerbank.setDataBank(new PlayerBank(playerbank, databank.getConnection()));
        playerbank.registerEvents("me.kt.playerbank");
        
        // Grundlegende Commands
        generalCommands = new Module("GeneralCommands", "Commands", TextFormatting.GOLD);
        generalCommands.registerCommands(e, "me.km.commands");
        
        // Chatmanager
        chatManager = new ChatManager("ChatManager", "Chat", TextFormatting.BLUE);
        chatManager.registerCommands(e, "me.km.chatmanager");
        chatManager.registerEvents("me.km.chatmanager");
        
        // AFK-Manager
        /*afkManager = new Module("AfkManager", "AFK", TextFormatting.GRAY);
        afkManager.registerCommands(e, "me.kt.afk");
        afkManager.registerEvents("me.kt.afk");*/
        
        // Plot-System
        /*plots = new Module("Plots", "Plots", TextFormatting.GOLD);
        plots.setDataBank(new ProtectionBank(plots, databank.getConnection()));
        plots.registerCommands(e, "me.kt.plots");          
        plots.registerEvents("me.kt.plots");*/
        
        // Chests- und Co-Protections
        /*blocks = new Module("BlockProtections", "Blocks", TextFormatting.BLUE);
        blocks.setDataBank(new BlockProtectionBank(blocks, databank.getConnection()));
        blocks.registerCommands(e, "me.kt.blockprotections");          
        blocks.registerEvents("me.kt.blockprotections");*/
        
        // DataTools
        /*datatools = new Module("DataTools", "DataTools", TextFormatting.GRAY);
        datatools.registerCommands(e, "me.kt.datatools");          
        datatools.registerEvents("me.kt.datatools");*/

        // Worldmanager
        /*worldManager = new WorldData("WorldManager", "Worlds", TextFormatting.RED);
        worldManager.registerCommands(e, "me.kt.worlds");          
        worldManager.registerEvents("me.kt.worlds");*/
        
        // Questsystem
        /*quest = new QuestAPI("Quests", "Quests", TextFormatting.LIGHT_PURPLE);
        quest.registerPrefix("Scripts", TextFormatting.LIGHT_PURPLE);
        quest.setDataBank(new QuestBank(quest, databank.getConnection()));
        quest.registerCommands(e, "me.kt.quests");          
        quest.registerEvents("me.kt.quests");*/
        
        // Jobsystem
        /*jobs = new JobAPI("JobSystem", "Jobs", TextFormatting.GREEN);
        jobs.setDataBank(new JobBank(jobs, databank.getConnection()));
        jobs.registerCommands(e, "me.kt.jobsystem");      
        jobs.registerEvents("me.kt.jobsystem"); */
        
        // Effectsystem
        /*effects = new EffectUtils("Effects", "Effects", TextFormatting.BLUE);
        effects.registerCommands(e, "me.kt.effects"); 
        effects.registerEvents("me.kt.effects.passive"); */
        
        // Skillshopsystem
        /*skills = new SkillManager("SkillSystem", "Skills", TextFormatting.BLUE);
        skills.registerCommands(e, "me.kt.skills"); 
        skills.registerEvents("me.kt.skills"); */
        
        // Scrollsystem
        /*scrolls = new Module("Scrolls", "Scrolls", TextFormatting.BLUE);
        scrolls.registerCommands(e, "me.kt.scrolls"); 
        scrolls.registerEvents("me.kt.scrolls");    */ 
        
        // Environment
        /*environment = new Module("Environment", "Environment", TextFormatting.GREEN);
        environment.registerCommands(e, "me.kt.environment");      
        environment.registerEvents("me.kt.environment");  */
        
        // Scoreboard
        scoreboard = new ScoreboardAPI("Scoreboard", "Scoreboard", TextFormatting.GOLD);
        scoreboard.registerEvents("me.km.scoreboard");
        
        // Customs
        /*customs = new Customs("Customs", "Customs", TextFormatting.GRAY);
        customs.registerCommands(e, "me.kt.custom");
        customs.registerEvents("me.kt.custom");*/
        
        // Piercing
        /*piercing = new PiercingAPI("Piercing", "Piercing", TextFormatting.DARK_PURPLE);
        piercing.registerEvents("me.kt.piercing.events");*/
          
        //quest.startScript(this.getServer().getConsoleSender(), "startscript");
    }
    
    @Mod.EventHandler
    public void serverStarting(FMLServerStoppingEvent e) 
    {
        databank.closeDataBankConnection();
    }

    @Mod.EventHandler
    public void init(FMLInitializationEvent event) 
    {
        ModEntities.init();
    }

    @Mod.EventHandler
    public void postInit(FMLPostInitializationEvent event) 
    {

    }
    
    /*public static void main(String[] args)
    {
        // Erstellt alle Enums für die aktiven Effekte
        PackageHelper.getClassesInIde("me.kt.effects.active").stream()
            .forEach(s -> 
            {
                StringBuilder en = new StringBuilder(s.substring(0, s.length() - 6));
                int i = 1;
                while(i < en.length())
                {
                    if(Character.isUpperCase(en.charAt(i)))
                    {
                        en.insert(i, "_");
                        i++;
                    } 
                    i++;
                }
                String wusi = "                        (true, " + s + "),";
                wusi = en.toString().toUpperCase() + wusi.substring(en.length());
                System.out.println(wusi);
            });
    }*/ 
}


 
