package me.km.chatmanager;

import me.km.api.Module;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.UUID;
import java.util.stream.Collectors;
import me.km.permissions.Permission;
import me.km.permissions.Permissions;
import net.minecraft.command.ICommandSender;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.util.text.TextFormatting;

public class ChatManager extends Module
{    
    private final ArrayList<List<Rank>> ranks;
    private final HashMap<UUID, String> fakeRank;

    public ChatManager(String mname, String prefix, TextFormatting color) 
    {
        super(mname, prefix, color);
        ranks = new ArrayList<>();
        ranks.add(Arrays.asList(new Rank("geist", "§8Geist")));
        fakeRank = new HashMap<>(); 
    }

    // -------------------------------------------------------------------------
    // Ränge registrieren und abrufen
    // -------------------------------------------------------------------------
    
    public void registerRank(String perm, int group, String name)
    {
        List<Rank> list;
        if(ranks.size() > group)
        {
            list = ranks.get(group);
        }
        else
        {
            list = new ArrayList<>();
            ranks.add(list);
        }
        list.add(new Rank(perm, name));
    }
    
    public ArrayList<String> getRanks(EntityPlayer p)
    {
        // TODO
        /*ArrayList<String> list = ranks.stream().skip(1)
                .map(l -> 
                {
                    for(Rank r : l)
                    {
                        if(false)
                        {
                            return r.getName();
                        }
                    }
                    return null;
                })
                .filter(s -> s != null)
                .collect(Collectors.toCollection(ArrayList::new));
        if(list.isEmpty())
        {
            list.add(ranks.get(0).get(0).getName());        
        }
        return list;*/
        return new ArrayList<>();
    }
    
    public void clearRanks()
    {
        ranks.clear();
        ranks.add(Arrays.asList(new Rank("geist", "§8Geist")));
    }
    
    public String getFullName(EntityPlayer p)
    {
        String fake = fakeRank.get(p.getUniqueID());
        if(fake != null)
        {
            return fake + " " + p.getDisplayName();
        }
        return getRanks(p).stream().collect(Collectors.joining("§r][", "[", "§r] " + p.getDisplayName()));
    }
    
    // -------------------------------------------------------------------------
    // Fakeranks
    // -------------------------------------------------------------------------
    
    public void addFakeRank(EntityPlayer p, String rank)
    {
        fakeRank.put(p.getUniqueID(), rank);
    }
    
    public String getFakeRank(EntityPlayer p)
    {
        return fakeRank.get(p.getUniqueID());
    }

    public void removeFakeRank(EntityPlayer p)
    {
        fakeRank.remove(p.getUniqueID());
    }
    
    // -------------------------------------------------------------------------
    // Text färben
    // -------------------------------------------------------------------------
    
    public static String colorMessage(String text, ICommandSender cs) 
    {
        text = text.replace("&k", "");
        if(Permission.hasPermission(cs, Permissions.USE_COLOR))
        {
            text = text.replace("&", "§");
            return text;
        }
        text = text.replaceAll("&.", "");
        return text;
    }
}
