package me.km.chatmanager;

import me.kt.KajetansTools;
import me.kt.api.GlobalText;
import me.kt.api.Module;
import me.kt.api.ModuleCommand;
import me.kt.api.Utils;
import me.kt.exceptions.PlayerNotFoundException;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

public class CommandFakeRank extends ModuleCommand
{
    public CommandFakeRank(Module m) 
    {
        super("fakerank", m);
        this.setDescription("Gibt einem Spieler einen falschen Rang");
        this.setUsage("/fakerank <rank/clear> [player]");
        this.setPermission("kt.fakerank");
    }

    @Override
    public boolean execute(CommandSender cs, String string, String[] arg) 
    {
        if(arg.length < 1)
        {
            return false;
        }
        Player affectedPlayer;
        try
        {
            affectedPlayer = Utils.getPlayerByName(arg[1]);                   
        }
        catch(PlayerNotFoundException ex)
        {
            this.getModule().send(cs, GlobalText.cantFindPlayer(arg[1]));
            return true;
        }
        catch(IndexOutOfBoundsException ex)
        {
            if(!(cs instanceof Player))
            {
                this.getModule().send(cs, GlobalText.missingParameter());
                return true;
            }
            affectedPlayer = (Player) cs;
        }
        
        if(arg[0].equals("clear"))
        {
            KajetansTools.chatManager.removeFakeRank(affectedPlayer);
            this.getModule().send(affectedPlayer, "Du hast keinen falschen Rang mehr.");
            if(!cs.equals(affectedPlayer))
            {
                this.getModule().send(cs, affectedPlayer.getName() + " hat keinen falschen Rang mehr.");
            }
            return true;
        }
        String rank = ChatManager.colorMessage(arg[0], cs);
        KajetansTools.chatManager.addFakeRank(affectedPlayer, rank);
        this.getModule().send(affectedPlayer, "Du hast nun den falschen Rang '" + rank + "§r'.");
        if(!cs.equals(affectedPlayer))
        {
            this.getModule().send(cs, affectedPlayer.getName() + " hat nun den falschen Rang '" + rank + "§r'.");
        }
        return true;
    }
}
