package me.km.chatmanager;

import me.kt.api.GlobalText;
import me.kt.api.Module;
import me.kt.api.ModuleCommand;
import me.kt.api.Utils;
import me.kt.exceptions.PlayerNotFoundException;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

public class CommandNickName extends ModuleCommand
{
    public CommandNickName(Module m) 
    {
        super("nickname", m);
        this.setDescription("Gibt einem Spieler einen Nickname");
        this.setUsage("/nickname <nick/clear> [player]");
        this.setPermission("kt.nickname");
    }

    @Override
    public boolean execute(CommandSender cs, String string, String[] arg) 
    {
        if(arg.length < 1)
        {
            return false;
        }
        Player affectedPlayer;
        try
        {
            affectedPlayer = Utils.getPlayerByName(arg[1]);                   
        }
        catch(PlayerNotFoundException ex)
        {
            this.getModule().send(cs, GlobalText.cantFindPlayer(arg[1]));
            return true;
        }
        catch(IndexOutOfBoundsException ex)
        {
            if(!(cs instanceof Player))
            {
                this.getModule().send(cs, GlobalText.missingParameter());
                return true;
            }
            affectedPlayer = (Player) cs;
        }
        
        if(arg[0].equals("clear") || arg[0].equals("off"))
        {
            affectedPlayer.setDisplayName(affectedPlayer.getName());
            affectedPlayer.setPlayerListName(affectedPlayer.getName());
            affectedPlayer.setCustomName(affectedPlayer.getName());
            this.getModule().send(affectedPlayer, "Du hast keinen Nicknamen mehr.");
            if(!cs.equals(affectedPlayer))
            {
                this.getModule().send(cs, affectedPlayer.getName() + " hat keinen Nicknamen mehr.");
            }
            return true;
        }
        affectedPlayer.setDisplayName(arg[0]);
        affectedPlayer.setPlayerListName(arg[0]);
        affectedPlayer.setCustomName(arg[0]);
        this.getModule().send(affectedPlayer, "Du hast nun den Nicknamen '" + arg[0] + "'.");
        if(!cs.equals(affectedPlayer))
        {
            this.getModule().send(cs, affectedPlayer.getName() + " hat nun den Nicknamen '" + arg[0] + "'.");
        }
        return true;
    }
}
