package me.km.commands;

import com.mojang.authlib.GameProfile;
import me.km.KajetansMod;
import me.km.api.GlobalText;
import me.km.api.ItemStackBuilder;
import me.km.api.Module;
import me.km.api.ModuleCommand;
import me.km.permissions.Permissions;
import net.minecraft.block.Block;
import net.minecraft.command.ICommandSender;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.init.Items;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.nbt.NBTUtil;
import net.minecraft.tileentity.TileEntitySkull;

public class CommandSkull extends ModuleCommand
{
    public CommandSkull(Module m) 
    {
        super("skull", m);
        super.setDescription("Gibt dir den Kopf eines Spielers");
        super.setUsage("/skull <owner>");
        super.setPermission(Permissions.SKULL);
    }

    @Override
    public boolean execute(ICommandSender cs, String[] arg) 
    {
        if(!(cs instanceof EntityPlayer))
        {
            this.getModule().send(cs, GlobalText.onlyPlayer());
            return true;
        }
        if(arg.length == 0)
        {
            return false;
        }
        EntityPlayer p = (EntityPlayer) cs;
        ItemStack stack = new ItemStackBuilder(Items.SKULL, 1, 3).build();
        
        NBTTagCompound com = stack.getTagCompound();
        if(com == null)
        {
            this.getModule().send(cs, GlobalText.shouldNotHappen());
            return true;
        }
        GameProfile gameprofile = KajetansMod.playerbank.getDataBank().getOfflinePlayer(arg[0]);
        gameprofile = TileEntitySkull.updateGameprofile(gameprofile);
        com.setTag("SkullOwner", NBTUtil.writeGameProfile(new NBTTagCompound(), gameprofile));
         
        Block.spawnAsEntity(p.getEntityWorld(), p.getPosition(), stack);
        this.getModule().send(cs, "Dir wurde ein Kopf von " + arg[0] + " gegeben.");
        return true;
    }
}
