package me.km.scheduler;

import java.util.HashMap;
import me.km.api.Module;
import net.minecraft.util.text.TextFormatting;

public class SnuviScheduler extends Module
{
    private int counter;
    private final HashMap<Integer, SnuviTask> tasks;
    
    public SnuviScheduler(String mname, String prefix, TextFormatting color)
    {
        super(mname, prefix, color);
        counter = 0;
        tasks = new HashMap<>();
    }
    
    public void cancelTask(int id)
    {
        tasks.remove(id);
    }
    
    public int scheduleRepeatingTask(Runnable r, long ticks, long rtimer)
    {
        counter++;
        tasks.put(counter, new SnuviTask(r, ticks, rtimer));
        return counter;
    }
    
    public int scheduleTask(Runnable r, int delay)
    { 
        return scheduleRepeatingTask(r, delay, 0);
    }
    
    public void tick()
    {
        tasks.values().removeIf(task -> task.tick());
    }
}
