package me.km.scoreboard;

import java.util.HashMap;
import java.util.UUID;
import me.km.KajetansMod;
import me.km.api.Module;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.util.text.TextFormatting;

public class ScoreboardAPI extends Module
{
    private HashMap<UUID, ScoreboardData> boards;
    
    public ScoreboardAPI(String mname, String prefix, TextFormatting color) 
    {
        super(mname, prefix, color);
        boards = new HashMap<>();
        KajetansMod.scheduler.scheduleRepeatingTask(new ScoreboardRefresher(this), 40, 30);
    }
    
    public void initScoreboardAPI()
    {
        boards = new HashMap<>();
    }
    
    public void addScoreboard(EntityPlayer p)
    {
        boards.put(p.getUniqueID(), new ScoreboardData());
    }
    
    public void removeScoreboard(EntityPlayer p)
    {
        boards.remove(p.getUniqueID(), new ScoreboardData());
    }
    
    public ScoreboardData getScoreboard(EntityPlayer p)
    {
        ScoreboardData data = boards.get(p.getUniqueID());
        if(data == null)
        {
            data = new ScoreboardData();
            boards.put(p.getUniqueID(), data);
            return data;
        }
        return boards.get(p.getUniqueID());
    }
    
    public void resetScoreboard(EntityPlayer p)
    {
        boards.put(p.getUniqueID(), new ScoreboardData());
    }
}
